#define ABS(a) (((a)<0) ? -(a) : (a))
#define ZSGN(a) (((a)<0) ? -1 : (a)>0 ? 1 : 0)

#define FOR_CASIO 1
#if FOR_CASIO
  #define XEKR 128
  #define SCR_SIZE 512
  #define VID_SEG 0x1a20
  #define SCR_MIDX 64
  #define SCR_MIDY 32
  #define SIZ 45
  #define PERS 100
#else
  #define XEKR 320
  #define SCR_SIZE 32000
  #define VID_SEG 0x0a000
  #define SCR_MIDX 160
  #define SCR_MIDY 100
  #define SIZ 50
  #define PERS 100
#endif

#define NumVertex 8
#define NumCon 12

#include <conio.h>
#include <stdio.h>
#if FOR_CASIO
//  typedef unsigned char ScrTabType [1024U];
//  ScrTabType ScrTab;
//  ScrTabType *VScrP=&ScrTab;
#else
#include <dos.h>
#include <malloc.h>
//  typedef unsigned char ScrTabType [64000U];
//  ScrTabType ScrTab;
//  ScrTabType *ScrP=&ScrTab;
//  ScrTabType *VScrP;
#endif
#include "sincost.c"
#include "line.c"

typedef cubeTabType [NumVertex][3];
cubeTabType Cube3dTab={
{-SIZ, SIZ, SIZ},
{ SIZ, SIZ, SIZ},
{ SIZ, SIZ,-SIZ},
{-SIZ, SIZ,-SIZ},

{-SIZ,-SIZ,-SIZ},
{-SIZ,-SIZ, SIZ},
{ SIZ,-SIZ, SIZ},
{ SIZ,-SIZ,-SIZ}
};
cubeTabType CubeRoTab;

int conTab [NumCon][2]={
{0,1},
{1,2},
{2,3},
{3,4},
{4,5},
{5,6},
{6,7},
{3,0},

{4,7},
{2,7},
{1,6},
{0,5}
};

int CoordScrTab [NumVertex][2];

void anykey (void) {
  if (getch()==0) getch ();
}

void clear_screen (unsigned int segm) {
  asm {
    mov ax,segm
    mov es,ax
    xor di,di
    xor ax,ax
    mov cx,SCR_SIZE
    rep stosw
  }
}

//!!!
void copy_screen (unsigned int SSeg, unsigned int DSeg){
  asm {
    push ds
    mov ds,SSeg
    mov es,DSeg
    xor si,si
    xor di,di
    mov cx,16000
    db 66h; rep movsw
    pop ds
  }
}

void rot_z0 (int x0 ,int y0 ,int x, int y, int z, int angle,
             int *xP,int *yP,int *zP) {
 int dx=x-x0;
 int dy=y-y0;
 *xP=x0 + dx * CosTab [angle]/256 + dy * SinTab [angle]/256;
 *yP=y0 + dy * CosTab [angle]/256 - dx * SinTab [angle]/256;
 *zP=z;
}

void rot_y0 (int x0 ,int z0 ,int x, int y, int z, int angle,
             int *xP,int *yP,int *zP) {
 int dx=x-x0;
 int dz=z-z0;
 *xP=x0 + dx * CosTab [angle]/256 - dz * SinTab [angle]/256;
 *zP=z0 + dz * CosTab [angle]/256 + dx * SinTab [angle]/256;
 *yP=y;
}

void rot_x0 (int y0 ,int z0 ,int x, int y, int z, int angle,
             int *xP,int *yP,int *zP) {
 int dy=y-y0;
 int dz=z-z0;
 *xP=x;
 *yP=y0 + dy * CosTab [angle]/256 + dz * SinTab [angle]/256;
 *zP=z0 + dz * CosTab [angle]/256 - dy * SinTab [angle]/256;
}



int main () {
  int angle;
  int n;
  int ViewX=0;
  int ViewY=0;
  int ViewZ=-500;

  clrscr ();
      //1234567890 1234567890
  puts ("CUBE3D v1.0 by\n"
        "Jarek 'Roeoender'\n"
        "       Wosik\n"
        "drzodrzo@kki.net.pl");

  anykey ();


#if FOR_CASIO
  asm {
    mov ax,0000h
    int 10h;
  }
#else
  asm {
    mov ax,0013h
    int 10h;
  }
//  VScrP= (ScrTabType *) malloc (64000U);
#endif

  for (angle=0;angle<=359;angle++) {
    ViewZ+=1;
    for (n=0;n<NumVertex;n++) {/* every vertex is rotated */
      rot_x0 (0,0, Cube3dTab [n][0], Cube3dTab [n][1], Cube3dTab [n][2],angle,
                  &CubeRoTab [n][0],&CubeRoTab [n][1],&CubeRoTab [n][2]);
      CoordScrTab[n][0]=SCR_MIDX + ( ( CubeRoTab [n][0] -  ViewX )*256/
                                ( CubeRoTab [n][2] - (ViewZ-PERS))*PERS)/256;
      CoordScrTab[n][1]=SCR_MIDY - ( ( CubeRoTab [n][1] -  ViewY )*256/
                                ( CubeRoTab [n][2] - (ViewZ-PERS))*PERS)/256;
    }
    for (n=0;n<NumCon;n++)
      {
        line (CoordScrTab [conTab [n][0]] [0],//CubeRoTab [conTab [n][0]] [2],
              CoordScrTab [conTab [n][0]] [1],// + CubeRoTab [conTab [n][0]] [2],
              CoordScrTab [conTab [n][1]] [0],// + CubeRoTab [conTab [n][1]] [2],
              CoordScrTab [conTab [n][1]] [1],VID_SEG);// + CubeRoTab [conTab [n][1]] [2]);
      }
    clear_screen (VID_SEG);
  }//big loop

  do
    for (angle=0;angle<=359;angle++) {
      for (n=0;n<NumVertex;n++) {/* every vertex is rotated */
        rot_z0 (0,0, Cube3dTab [n][0], Cube3dTab [n][1], Cube3dTab [n][2],angle,
                    &CubeRoTab [n][0],&CubeRoTab [n][1],&CubeRoTab [n][2]);
        rot_y0 (0,0, CubeRoTab [n][0], CubeRoTab [n][1], CubeRoTab [n][2],angle,
                    &CubeRoTab [n][0],&CubeRoTab [n][1],&CubeRoTab [n][2]);
        rot_x0 (0,0, CubeRoTab [n][0], CubeRoTab [n][1], CubeRoTab [n][2],angle,
                    &CubeRoTab [n][0],&CubeRoTab [n][1],&CubeRoTab [n][2]);
        CoordScrTab[n][0]=SCR_MIDX + ( ( CubeRoTab [n][0] -  ViewX )*256/
                                  ( CubeRoTab [n][2] - (ViewZ-PERS))*PERS)/256;
        CoordScrTab[n][1]=SCR_MIDY - ( ( CubeRoTab [n][1] -  ViewY )*256/
                                  ( CubeRoTab [n][2] - (ViewZ-PERS))*PERS)/256;
      }
      for (n=0;n<NumCon;n++)
        {
          line (CoordScrTab [conTab [n][0]] [0],//CubeRoTab [conTab [n][0]] [2],
                CoordScrTab [conTab [n][0]] [1],// + CubeRoTab [conTab [n][0]] [2],
                CoordScrTab [conTab [n][1]] [0],// + CubeRoTab [conTab [n][1]] [2],
                CoordScrTab [conTab [n][1]] [1],VID_SEG);// + CubeRoTab [conTab [n][1]] [2]);
        }
      clear_screen (VID_SEG);
    }
  while (!kbhit ());
  anykey ();
  return 0;
}//main